%bcond_without python

%define __python %{__python3}

# cvs -d:pserver:anonymous@lirc.cvs.sourceforge.net:/cvsroot/lirc login
# cvs -z8 -d:pserver:anonymous@lirc.cvs.sourceforge.net:/cvsroot/lirc co lirc
%define snapshot	0
%define prever		0
%define rel		10

%if %snapshot
%define release		%mkrel 0.%{snapshot}.%{rel}
%define distname	%{name}-%{snapshot}.tar.bz2
%define dir		%{name}
%else
%if %prever
%define release		%mkrel 0.pre%{prever}.%{rel}
%define distname	%{name}-%{version}pre%{prever}.tar.bz2
%define distdir		%{name}-%{version}pre%{prever}
%else
%define	release		%mkrel %{rel}
%define distname	%{name}-%{version}.tar.bz2
%define distdir		%{name}-%{version}
%endif
%endif

%define	major		0
%define libname 	%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

# Kernel modules are unmaintained and do not build against current
# kernels without more work.
%define build_dkms	0

Summary:	Linux Infrared Remote Control daemons
Name:		lirc
Version:	0.10.1
Release:	%{release}
License:	GPLv2+
Group:		System/Kernel and hardware
URL:		http://www.lirc.org/
Source0:	http://prdownloads.sourceforge.net/lirc/%{distname}
Source5:	http://svn.debian.org/viewsvn/pkg-lirc/lirc/trunk/debian/liblircclient0.pc
Source6:	%{name}-tmpfiles.conf
Source1:	README.mageia
Source2:	99-remote-control-lirc.rules
Patch2:		0002-lirc-setup-Fix-crash-on-start-on-missing-lirc.config.patch
Patch100:	0001-Use-runstatedir-from-upcoming-autoconf-0.70.patch
Patch101:	0001-Update-lirc_options.conf-after-runstatedir-addition.patch
# For patch100
BuildRequires:	autoconf >= 2.69-13
BuildRequires:	doxygen
BuildRequires:	expect
BuildRequires:	man2html
BuildRequires:	pkgconfig(x11)
BuildRequires:	libirman-devel
BuildRequires:	pkgconfig(libusb)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(libftdi1)
BuildRequires:	pkgconfig(portaudio-2.0)
BuildRequires:	help2man
BuildRequires:	xsltproc
BuildRequires:	pkgconfig(python3)
BuildRequires:	pkgconfig(systemd)
%if %with python
BuildRequires:	python3-setuptools
BuildRequires:	python3-yaml
Requires:	python3-yaml
%endif
Requires:	python3-gobject3
Requires(post):	systemd >= %{systemd_required_version}
Requires(post):	rpm-helper
Requires(preun):rpm-helper

%description
LIRC is a package that allows you to decode and send infra-red signals
of many (but not all) commonly used remote controls.

%package -n	%{libname}
Summary:	LIRC libraries
Group:		System/Libraries

%description -n	%{libname}
This package provides the libraries necessary to run lirc client
programs.

%package -n	%{develname}
Summary:	Header and library files for LIRC development
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname lirc 0 -d}

%description -n	%{develname}
This package provides the files necessary to develop LIRC-based
programs.

%package -n	dkms-%{name}-extra
Summary:	Additional LIRC kernel drivers
Group:		System/Kernel and hardware
Obsoletes:	dkms-lirc-parallel < 0.8.7-1
Provides:	dkms-lirc-parallel = %{version}-%{release}
Obsoletes:	dkms-lirc < 0.9.1
Provides:	dkms-lirc = %{version}-%{release}
Obsoletes:	dkms-lirc-gpio < 0.9.1
Provides:	dkms-lirc-gpio = %{version}-%{release}
Requires(post):	dkms
Requires(preun): dkms

%description -n	dkms-%{name}-extra
This package provides additional LIRC kernel drivers that are not included
in the standard Linux kernel:
 - lirc_atiusb
 - lirc_i2c
 - lirc_wpc8769l

Install this package if you use a device that requires their use.

%package	remotes
Summary:	LIRC remote definitions
Group:		System/Kernel and hardware

%description    remotes
A collection of remote control configuration files for LIRC.

%package	disable-kernel-rc
Summary:	Disable kernel IR device handling in favor of lirc
Requires:	%{name} = %{version}-%{release}
Group:		System/Kernel and hardware

%description  disable-kernel-rc
Udev rule which disables the kernel built-in handling of infrared devices
(i. e., rc* ones) by making lirc the only used protocol. An alternative is
to use the LIRCD_IR_DEVICE option in /etc/sysconfig/lirc.

%prep
%setup -q -n %{distdir}
%autopatch -p1
# Our Arm build nodes run Ubuntu kernel and for some reason
# they decided to use kernel version to set systemd dir path
# to an hardcoded value on Ubuntu and ignore --with-systemdsystemunitdir
sed -i s/Ubuntu/xXXXXXXXx/ configure.ac

%build
autoreconf -fi

%configure	--localstatedir=/var \
		--runstatedir=%{_rundir} \
		--enable-uinput \
		--enable-devinput \
		--with-lockdir=/run/lock/lockdev \
		--with-systemdsystemunitdir=%{_unitdir} \
		--with-x

%make_build LANG=C.utf8

%if %snapshot
make -C doc release
%endif

%install
mkdir -p %{buildroot}%{_datadir}/aclocal
mkdir -p %{buildroot}%{_var}/log

%make_install

# mangle python shebangs
sed -i -e '1s,#!/usr/bin.*python[2,3]\?,#!%__python3,' $(grep -r -l '#!/usr/bin/.*python' %{buildroot}{%{_bindir},%{_sbindir},%{python3_sitearch}/lirc-setup})

cp -a %{SOURCE1} README.mageia
install -Dpm 644 %{SOURCE2} \
    %{buildroot}%{_udevrulesdir}/99-remote-control-lirc.rules

install -m644 %{SOURCE5} -D %{buildroot}%{_libdir}/pkgconfig/liblircclient0.pc
sed -i -e "s/0.8.3/%version/" -e "s^/lib^/%_lib^" %{buildroot}%{_libdir}/pkgconfig/liblircclient0.pc
install -D -p -m 0644 %{SOURCE6} %{buildroot}%{_tmpfilesdir}/%{name}.conf

mkdir -p %{buildroot}%{_sysconfdir}/lirc
cat > %{buildroot}%{_sysconfdir}/lirc/lircd.conf<<END
#
# This is a placeholder for your configuration file.
# See %{_datadir}/%{name}-remotes for some examples.
# You might need to install %{name}-remotes package.
#
END

cp -f %{buildroot}%{_sysconfdir}/lirc/lirc{,m}d.conf

# dkms
%if %build_dkms

for lircsrcdir in %{name}-extra; do

install -d -m755 %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}
cp -a Makefile Makefile.in Makefile.am acinclude.m4 \
	configure.ac config.status config.h \
	%{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}

# Makefiles call there to unnecessarily regenerate files
echo '#!/bin/true' > %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}/configure
chmod +x %{buildroot}/usr/src/$lircsrcdir-%{version}-%{release}/configure

done

cp -a drivers %{buildroot}/usr/src/%{name}-extra-%{version}-%{release}

drivers="lirc_atiusb lirc_i2c lirc_wpc8769l"

cat > %{buildroot}/usr/src/%{name}-extra-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{name}"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="droot=\\\$(pwd); for driver in $drivers; do cd \\\$droot/drivers/\\\$driver; make \
	KERNEL_LOCATION=\$kernel_source_dir AUTOMAKE=true AUTOCONF=true ACLOCAL=true; done"
CLEAN="droot=\\\$(pwd); for driver in $drivers; do cd \\\$droot/drivers/\\\$driver; make \
	clean AUTOMAKE=true AUTOCONF=true ACLOCAL=true; done"
AUTOINSTALL=yes
EOF

i=0
for module in $drivers; do
	cat >> %{buildroot}/usr/src/%{name}-extra-%{version}-%{release}/dkms.conf <<-EOF
	BUILT_MODULE_NAME[$i]="$module"
	BUILT_MODULE_LOCATION[$i]="drivers/$module"
	DEST_MODULE_LOCATION[$i]="/kernel/drivers/input/misc"
	EOF
	i=$((i+1))
done
%endif

cat > README.0.8.6-2.upgrade.urpmi <<EOF
As of LIRC 0.8.6, the config file locations have changed to
/etc/lirc/lircd.conf, /etc/lirc/lircmd.conf, and /etc/lirc/lircrc.
Existing files have been moved to these locations automatically.
The socket location has changed to /run/lirc/lircd.
EOF

cat > README.0.9.0-11.upgrade.urpmi <<EOF
The LIRC service now has a configuration file in /etc/sysconfig/lirc.

Existing driver and device configurations should have been automatically
migrated, but in some cases you may need to edit it manually.
EOF

rm -rf %{buildroot}%{_datadir}/lirc/lirc-%{version}.tar.gz
find %{buildroot} -name '*.la' -delete

# Remove recursive loop symlink
rm -f %{buildroot}%{_datadir}/doc/lirc/lirc.org/api-docs/api-docs


%pre
if [ $1 = 2 ] && ! [ -e %{_sysconfdir}/lirc ]; then
	mkdir -p %{_sysconfdir}/lirc
	touch %{_sysconfdir}/lirc/mdv-086-migration
fi

# migrate settings from old sysconfig/service files
if [ $1 = 2 ] && [ -e %{_sysconfdir}/lirc ] && ! [ -e %{_sysconfdir}/sysconfig/lirc ]; then
	driver=
	device=
	
	if [ -e "%{_unitdir}/lircd.service" ] && [ "$(md5sum %{_unitdir}/lircd.service)" != "3172f21552e11c04a41955b2d472134d" ]; then
		# try to keep user modifications of hardcoded lircd.service files
		driver="$(sed -rn 's,^ExecStart.*--driver=([^ ]+).*$,\1,p' %{_unitdir}/lircd.service)"
		device="$(sed -rn 's,^ExecStart.*--device=([^ ]+).*$,\1,p' %{_unitdir}/lircd.service)"

	elif [ -e "%{_sysconfdir}/sysconfig/lircd" ] && [ "$(md5sum %{_sysconfdir}/sysconfig/lircd)" != "c0179720835ceccd7e99ec1c7c0930cf" ]; then
		# try to keep settings from pre-systemd sysconfig files
		driver="$(sed -rn 's,^DRIVER="?([^"]+)"?.*$,\1,p' %{_sysconfdir}/sysconfig/lircd)"
		device="$(sed -rn 's,^DEVICE="?([^"]+)"?.*$,\1,p' %{_sysconfdir}/sysconfig/lircd)"
	fi

	if [ -n "$driver" ] && [ -n "$device" ]; then
		echo "$driver" > %{_sysconfdir}/lirc/mga-090-migration-driver
		echo "$device" > %{_sysconfdir}/lirc/mga-090-migration-device
	fi
fi

%post
%_tmpfilescreate %{name}
%create_ghostfile /var/log/lircd root root 644
if [ $1 = 2 ] && [ -e %{_sysconfdir}/lirc/mdv-086-migration ]; then
	mv -vf %{_sysconfdir}/lircd.conf %{_sysconfdir}/lirc/lircd.conf 2>/dev/null
	mv -vf %{_sysconfdir}/lircmd.conf %{_sysconfdir}/lirc/lircmd.conf 2>/dev/null
	mv -vf %{_sysconfdir}/lircrc %{_sysconfdir}/lirc/lircrc 2>/dev/null
	rm -f %{_sysconfdir}/lirc/mdv-086-migration
fi
if [ $1 = 2 ] && [ -e %{_sysconfdir}/lirc/mga-090-migration-driver ] && [ -e %{_sysconfdir}/lirc/mga-090-migration-device ]; then
	driver="$(cat %{_sysconfdir}/lirc/mga-090-migration-driver)"
	device="$(cat %{_sysconfdir}/lirc/mga-090-migration-device)"
	sed -i "s,^LIRC_DRIVER=.*\$,LIRC_DRIVER=\"$driver\"," %{_sysconfdir}/sysconfig/lirc
	sed -i "s,^LIRC_DEVICE=.*\$,LIRC_DEVICE=\"$device\"," %{_sysconfdir}/sysconfig/lirc
	rm -f %{_sysconfdir}/lirc/mga-090-migration-driver
	rm -f %{_sysconfdir}/lirc/mga-090-migration-device
fi
%_post_service lircd
%_post_service lircmd

%preun
%_preun_service lircmd
%_preun_service lircd

%post -n dkms-%{name}-extra
dkms add     -m %{name}-extra -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build   -m %{name}-extra -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{name}-extra -v %{version}-%{release} --rpm_safe_upgrade --force
true

%preun -n dkms-%{name}-extra
dkms remove  -m %{name}-extra -v %{version}-%{release} --rpm_safe_upgrade --all
true

%files
%doc README.0.8.6-2.upgrade.urpmi
%doc README.0.9.0-11.upgrade.urpmi
%doc README.mageia
%doc AUTHORS NEWS README ChangeLog 
%doc contrib/irman2lirc doc/irxevent.keys
%doc doc/html
%{_unitdir}/*
%{_tmpfilesdir}/%{name}.conf
%dir %{_sysconfdir}/lirc
%config(noreplace) %{_sysconfdir}/lirc/*
%{_bindir}/*
%{_sbindir}/*
%{_mandir}/*/*
%dir %{_datadir}/lirc
%{_datadir}/lirc/contrib/
%{_datadir}/lirc/configs/
%{_datadir}/lirc/python-pkg/
%{_libdir}/lirc/
%{_var}/lib/lirc/
%{python3_sitearch}/*
%{_datadir}/lirc/lirc.hwdb
%{_datadir}/doc/lirc/images

%files -n %{libname}
%{_libdir}/*.so.%{major}{,.*}

%files -n %{develname}
%{_libdir}/pkgconfig/*.pc
%{_includedir}/lirc*
%{_libdir}/*.so
%{_datadir}/doc/lirc/lirc.org/
%{_datadir}/doc/lirc/plugindocs
%{_datadir}/doc/lirc/VERSION


%if %build_dkms
%files -n dkms-%{name}-extra
%{_prefix}/src/%{name}-extra-%{version}-%{release}
%endif

%files disable-kernel-rc
%{_udevrulesdir}/99-remote-control-lirc.rules



%changelog
* Sun Mar 22 2020 kekepower <kekepower> 0.10.1-10.mga8
+ Revision: 1558883
- Remove recursive loop symlink in docs

* Sun Feb 16 2020 umeabot <umeabot> 0.10.1-9.mga8
+ Revision: 1531529
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Thu Sep 12 2019 wally <wally> 0.10.1-8.mga8
+ Revision: 1440030
- rebuild for python3.8
- mangle python shebangs

* Sat Feb 16 2019 wally <wally> 0.10.1-7.mga7
+ Revision: 1367556
- update lirc_options.conf to also use /run instead of /var/run

* Sat Feb 16 2019 wally <wally> 0.10.1-6.mga7
+ Revision: 1367544
- use /run instead of /var/run as runstatedir
- use /run/lock instead of /var/lock
+ daviddavid <daviddavid>
- add missing dependency on python3-gobject3

* Wed Jan 16 2019 daviddavid <daviddavid> 0.10.1-5.mga7
+ Revision: 1357365
- enable portaudio support

* Wed Jan 16 2019 daviddavid <daviddavid> 0.10.1-4.mga7
+ Revision: 1357361
- add upstream to fix crash on start on missing lirc.config (mga#24102)
- requires python3-yaml

* Tue Jan 08 2019 daviddavid <daviddavid> 0.10.1-3.mga7
+ Revision: 1352792
- rebuild for new Python 3.7

* Fri Sep 28 2018 umeabot <umeabot> 0.10.1-2.mga7
+ Revision: 1309233
- Mageia 7 Mass Rebuild

* Wed Jun 13 2018 daviddavid <daviddavid> 0.10.1-1.mga7
+ Revision: 1236667
- new version: 0.10.1
- remove merged upstream patch
- remove unwanted '.la' files

* Sun Jun 03 2018 wally <wally> 0.10.0-5.mga7
+ Revision: 1233975
- drop iguanair BR (unused since lirc >= 0.9.4)

* Sat Jan 27 2018 pterjan <pterjan> 0.10.0-4.mga7
+ Revision: 1197297
- Fix build on arm

* Fri Oct 27 2017 pterjan <pterjan> 0.10.0-3.mga7
+ Revision: 1173916
- Use make_build and drop old comment
- Set systemd unit dir
- Drop not longer supported configure options

* Fri Sep 22 2017 tv <tv> 0.10.0-2.mga7
+ Revision: 1157438
- adjust filelist (was OK locally???)
- adjust filelist (was OK locally???)
- new release

* Fri Feb 05 2016 umeabot <umeabot> 0.9.1a-4.mga6
+ Revision: 939458
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 0.9.1a-3.mga5
+ Revision: 750320
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.9.1a-2.mga5
+ Revision: 681957
- Mageia 5 Mass Rebuild

* Sat Aug 23 2014 luigiwalser <luigiwalser> 0.9.1a-1.mga5
+ Revision: 666890
- 0.9.1a
- remove systemd files (now upstream)
- remove no longer used sysconfig file
- update README.mageia (from fedora)

* Thu Jul 10 2014 luigiwalser <luigiwalser> 0.9.1-1.mga5
+ Revision: 651140
- 0.9.1
- remove upstreamed patches
- fix another format string issue

* Sat Jul 05 2014 pterjan <pterjan> 0.9.0-15.mga5
+ Revision: 643739
- Replace libusb*-devel BuildRequires by better ones

* Tue Mar 04 2014 anssi <anssi> 0.9.0-14.mga5
+ Revision: 599313
- mark sysconfig file as config file

* Mon Mar 03 2014 anssi <anssi> 0.9.0-13.mga5
+ Revision: 598942
- sysconfig: allow LIRCD_OPTIONS to override LIRC_DRIVER and LIRC_DEVICE
  (see bug #12685, suggested by Bit Twister)

* Tue Feb 11 2014 anssi <anssi> 0.9.0-12.mga5
+ Revision: 589362
- drop dkms-lirc-extra for now, the drivers do not work with current
  kernels and do not have an active upstream
- avoid showing upgrade information twice

* Sun Feb 09 2014 anssi <anssi> 0.9.0-11.mga5
+ Revision: 587211
- add /etc/sysconfig/lirc based on Fedora, and migrate major old
  settings from lircd.service and sysconfig/lircd (mgabz #9528)
- add LIRC_IR_DEVICE configuration directive and
  lirc-disable-kernel-rc subpackage as ways to override kernel RC
  protocol allowing LIRC to work properly (mgabz #1265)
- remove udev configuration file which tried to rename /dev/lirc0
  to /dev/lirc/0, the former name is what should be used
  (mgabz #10537)
- remove unneeded requires on setserial
- add a README.mageia file based on Fedora
- add assorted fixes from upstream and Fedora

* Sat Oct 19 2013 umeabot <umeabot> 0.9.0-10.mga4
+ Revision: 522643
- Mageia 4 Mass Rebuild

* Sun Mar 24 2013 colin <colin> 0.9.0-9.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Sat Feb 23 2013 guillomovitch <guillomovitch> 0.9.0-8.mga3
+ Revision: 400114
- switch to native systemd services

* Sun Jan 13 2013 colin <colin> 0.9.0-7.mga3
+ Revision: 375472
- Fix udev rules location
- Switch to tmpfiles for [/var]/run dirs

* Sat Jan 12 2013 umeabot <umeabot> 0.9.0-6.mga3
+ Revision: 358865
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Dec 26 2012 pterjan <pterjan> 0.9.0-5.mga3
+ Revision: 335466
- Better fix for new rpm

* Wed Dec 26 2012 pterjan <pterjan> 0.9.0-4.mga3
+ Revision: 335429
- Workaround new rpm limitation

* Thu Sep 29 2011 fwang <fwang> 0.9.0-3.mga2
+ Revision: 150174
- tighten br

* Fri Sep 09 2011 tv <tv> 0.9.0-2.mga2
+ Revision: 141647
- add missing LSB keywords
+ anssi <anssi>
- new version
  o fixes compatibility with in-kernel LIRC on 64-bit systems
- drop dkms-lirc as most DKMS modules are now in-kernel
- provide dkms-lirc-extra with the missing modules lirc_atiusb, lirc_i2c,
  lirc_wpc8769l (the package obsoletes dkms-lirc)
- drop patch applied upstream

* Fri Jan 14 2011 anssi <anssi> 0.8.7-1.mga1
+ Revision: 17702
- new version
- merge dkms-lirc-parallel back to dkms-lirc
- disable dkms-lirc-gpio for now, it doesn't seem to be useful
  (doesn't build with recent kernels)
+ dmorgan <dmorgan>
- Remove mdv macros
- imported package lirc

